

/* Program cac10 */
/* Handling system components */

#include "cacint.h"

int main()
{
  LI noerr, nscom, i;
  char fname[13], scname[TQSTRLEN];
  

  /* Initialise ChemApp */ 
  tqini(&noerr);

  strcpy(fname,"cosi.dat");

  /* Open the thermochemical data-file cosi.dat (system C-O-Si)
     for reading */
  tqopna(fname,10,&noerr);

  /* Read data-file */
  tqrfil(&noerr);
  
  /* Close data-file */
  tqclos(10,&noerr);
   
  /* Get the number of system components */
  tqnosc(&nscom, &noerr);

  printf("Number of system component in file %s: %li\n", fname, nscom);


  /* Print the names of all system components */
  printf("Names of system components:\n");

  for (i = 1; i <= nscom; i++) {
    tqgnsc(i, scname, &noerr);
    printf("%li: %s\n", i, scname);
  }


  /* Get the index number of a system component */
  tqinsc("C", &i, &noerr);
  printf("C (Carbon) is system component no. %li in file %s\n", 
	 i, fname);


  return 0;
 
}


