

/* Program cac12 */
/* Handling phases */

#include "cacint.h"

int main()
{
  LI noerr, nphase, i;
  char pname[TQSTRLEN], mname[TQSTRLEN];
  

  /* Initialise ChemApp */ 
  tqini(&noerr);

  /* Open the thermochemical data-file cosi.dat (system C-O-Si)
     for reading */
  tqopna("cosi.dat",10,&noerr);

  /* Read data-file */
  tqrfil(&noerr);
  
  /* Close data-file */
  tqclos(10,&noerr);
   
  /* Get the number of phases */
  tqnop(&nphase, &noerr);

  printf("Number of phases in file cosi.dat: %li\n", nphase);


  /* Print the names and models of all phases */
  printf("No.  Name of phase            Model\n");

  for (i = 1; i <= nphase; i++) {
    tqgnp(i, pname, &noerr);
    tqmodl(i, mname, &noerr);
    printf("%3li  %-24s %-6s\n", i, pname, mname);
  }


  /* Get the index number of a phase */
  tqinp("SiC", &i, &noerr);
  printf("SiC is phase no. %li in file cosi.dat\n", i);


  return 0;
 
}


