

/* Program cac13 */
/* Handling phase constituents*/

#include "cacint.h"

int main()
{
  LI noerr, npcon, nscom, i;
  char pcname[TQSTRLEN], scname[3][TQSTRLEN];
  DB wmass, stoi[3];

  /* Initialise ChemApp */ 
  tqini(&noerr);

  /* Open the thermochemical data-file cosi.dat (system C-O-Si)
     for reading */
  tqopna("cosi.dat",10,&noerr);

  /* Read data-file */
  tqrfil(&noerr);
  
  /* Close data-file */
  tqclos(10,&noerr);
   
  /* Get the number of phase constituents of the first phase in 
     cosi.dat, which is the gaseous mixture phase */
  tqnopc(1, &npcon, &noerr);

  printf("Number of phase constituents of "
	 "the gas phase in cosi.dat: %li\n", npcon);


  /* Print the names of all phase constituents of the gas phase,
     their stoichiometry in terms of the system components, 
     and their molecular masses */

  /* Get names of the system components */
  tqnosc(&nscom, &noerr);
  for (i = 1; i <= nscom; i++) {
    tqgnsc(i, scname[i-1], &noerr);
  }

  /* Print header */
  printf("                                 "
	 "Stoichiometry    Mol. mass\n");
  printf("No. Name of phase const.    %6s%6s%6s    g/mol\n",
	 scname[0],scname[1],scname[2]);

  /* Set amount unit to gram, so we get the molecular mass in g/mol */
  tqcsu("Amount", "gram", &noerr);

  /* Get the information on all phase constituents of 
     the gas phase */
  for (i = 1; i <= npcon; i++) {
    tqgnpc(1, i, pcname, &noerr);
    tqstpc(1, i, stoi, &wmass, &noerr);
    printf("%3li %-26s%6.1f%6.1f%6.1f  %g\n", 
	   i, pcname, stoi[0], stoi[1], stoi[2], wmass); 
  }


  /* Get the index number of a phase constituent,
     in this case, CO2 in the gas phase */
  tqinpc("CO2", 1, &i, &noerr);
  printf("CO2 is phase constituent no. %li "
	 "in the gas phase in file cosi.dat\n", i);


  return 0;
 
}


