

/* Program cac21 */
/* Retrieve error messages */

#include "cacint.h"

int main()
{
  LI noerr, nphase;
  int i;

  /* Initialise ChemApp */ 
  tqini(&noerr);

  /* tqerr is especially useful if is undesirable that ChemApp writes
     error messages to standard output. If the application program
     which calls ChemApp has a graphical user interface, ChemApp error
     messages written to standard output might either not be displayed
     at all, or might corrupt the graphical interface window. In these
     cases it is more useful to have ChemApp not output error messages
     automatically, but retrieve them using tqerr, if the error
     variable returned by a ChemApp function indicates that an error
     occurred. */

  /* Prevent the error messages from being displayed automatically */
  tqcio("ERROR", 0, &noerr);

  /* Provoke an error by trying to get the number of phases before
     even having read a thermochemical data-file */
  tqnop(&nphase, &noerr);
  if (noerr) {
    printf(" ChemApp reports error no. %li\n", noerr);

    /* Retrieve the error message using tqerr. The variable TQERRMSG
       to be used for that purpose is declared in cacint.c as
       TQERRMSG[3][80] */
    tqerr(TQERRMSG,&noerr);

    /* To display the message, print all three strings of TQERRMSG: */
    for(i=0;i<3;i++) 
      printf("%s\n",TQERRMSG[i]);


  }

  return 0;
 
}


