

/* Program cac29 */
/* Read a thermochemical data-file in BINARY format*/

/* NOTE: This example program requires a data-file in binary format 
         to run, which is not part of a regular distribution of ChemApp
         or ChemApp "light". */

#include "cacint.h"

int main()
{
  LI noerr;
 
  /* Initialise ChemApp */ 
  tqini(&noerr);

  /* Note that tqopnb is used to open the thermochemical data-file,
     instead of a standard C library routine like fopen. The reason
     is that it is necessary to associate the data-file with a
     particular FORTRAN unit number (10 by default, see tqgio) so
     that the FORTRAN subroutine tqrbin can read from the correct
     file */
  tqopnb("cosi.bin",10,&noerr);

  /* Read data-file */
  tqrbin(&noerr);
  
  /* Close data-file */
  /* Again, the routine for closing the data-file is not a standard
     C library routine like fclose, but a special one to make sure the
     file that was previously opened under the unit number specified
     is closed. */
  tqclos(10,&noerr);
   
  return 0;
 
}


