

/* Program cac30 */
/* Retrieving and displaying the user ID and the name of the ChemApp
   license holder, as well as the program ID */

/* If the ChemApp version used requires a HASP dongle, and the ChemApp
   license is expired, or about to expire, and is to be extended, the
   information printed by this program is needed by GTT-Technologies
   to update the dongle. */

#include "cacint.h"

int main()
{
  LI noerr, haspid, edmon, edyear;

  char id[255], name[80], pid[TQSTRLEN], haspt[TQSTRLEN];
 
  /* Initialise ChemApp */ 
  tqini(&noerr);
    
  /* Retrieve the licensee's user ID */
  tqgtid(id, &noerr);

  /* Retrieve the licensee's name */
  tqgtnm(name, &noerr);

  /* Retrieve the program ID */
  tqgtpi(pid, &noerr);

  /* Print all three */
  printf("Licensee's user ID: %s\n", id);
  printf("Licensee's name   : %s\n", name);
  printf("Program ID        : %s\n", pid);


  /* The following pieces of information are only meaningful if a
      version of ChemApp is used that requires a dongle (hardware
      key).  Get the HASP dongle type and id */
  tqgthi(haspt, &haspid, &noerr);

  /* Get the ChemApp license expiration date (month and year) */
  tqgted(&edmon, &edyear, &noerr);

  /* Print info if HASP dongle is used: */
  if (haspid) {
    printf("HASP dongle type : %s\n", haspt);
    printf("HASP dongle id   : %li\n", haspid);
    printf("ChemApp license expiration date (month/year): %li/%li\n", 
	   edmon, edyear);
  } else {
    printf("This ChemApp version does not require a "
	   "HASP hardware key (dongle)\n");
  }  


  return 0;

}





