

/* Program cac32 */
/* Redirecting ChemApp output and user-defined text to the same file */

#include "cacint.h"

int main()
{
  LI noerr, funit, lunit, ipc, numcon;
  char logtxt[80];
  DB co2amt, darray2[2];
  

  /* Initialise ChemApp */ 
  tqini(&noerr);

  /* Get the unit number from which the thermochemical data-file
     will be read */
  tqgio("file", &funit, &noerr);
  
  /* Open the thermochemical data-file cosi.dat (system C-O-Si)
     for reading */
  tqopna("cosi.dat", funit, &noerr);

  /* Read data-file */
  tqrfil(&noerr);
  
  /* Close data-file */
  tqclos(funit,&noerr);
   
  /* Input 3 mol of CO2/GAS/ */
  co2amt = 3.0;
  tqinpc("CO2", 1, &ipc, &noerr);
  tqsetc("ia ", 1, ipc, co2amt, &numcon, &noerr);

  /* Redirect "list" output (e.g. output from tqcel) to a different
     unit number */
  lunit = 21;
  tqcio("list", lunit, &noerr);

  /* Open a file under this unit number */
  tqopen("cac32.rst", lunit, &noerr);
 
  /* Write a descriptive text to file "result" */
  tqwstr("list", "Output from tqcel (ChemSage result table)", &noerr);

  sprintf(logtxt, "Incoming amount of CO2 in mol: %li", co2amt);
  
  tqwstr("list", logtxt, &noerr);
  
  /* Write ChemSage result table to file "result" */
  tqcel(" ", 0, 0, darray2, &noerr);

  /* Direct "list" output back to the standard output unit */
  tqcio("list", 6, &noerr);

  /* Close the file "result" */
  tqclos(lunit, &noerr);

  return 0;
 
}


