

/* Program cac7 */
/* Read a thermochemical data-file in ASCII format*/

#include "cacint.h"

int main()
{
  LI noerr;
 
  /* Initialise ChemApp */ 
  tqini(&noerr);

  /* Note that tqopna is used to open the thermochemical data-file,
     instead of a standard C library routine like fopen. The reason
     is that it is necessary to associate the data-file with a
     particular FORTRAN unit number (10 by default, see tqgio) so
     that the FORTRAN subroutine tqrfil can read from the correct
     file */
  tqopna("cosi.dat",10,&noerr);
  if (noerr) {
    printf("ERROR: Cannot open data-file.");
    exit(noerr);
  }

  /* Read data-file */
  tqrfil(&noerr);
  
  /* Close data-file */
  /* Again, the routine for closing the data-file is not a standard
     C library routine like fclose, but a special one to make sure the
     file that was previously opened under the unit number specified
     is closed. */
  tqclos(10,&noerr);
   
  return 0;
 
}


