
C Handling system components

      PROGRAM CAF10
      IMPLICIT NONE
      
      INTEGER NOERR, NSCOM, I
      CHARACTER FNAME*12, SCNAME*24

C Initialise ChemApp 
      CALL TQINI(NOERR)

      FNAME = 'cosi.dat'

C Open the thermochemical data-file cosi.dat (system C-O-Si)
C for reading
      CALL TQOPNA(FNAME, 10, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)

C Get the number of system components
      CALL TQNOSC(NSCOM, NOERR)

      WRITE(*,FMT='(A,I3)') 'Number of system components ' //
     *                      'in file ' // FNAME // ':', NSCOM 

      
C Print the names of all system components
      WRITE(*,FMT='(A)') 'Names of system components:'

      DO I=1, NSCOM
         CALL TQGNSC(I, SCNAME, NOERR)
         WRITE(*,FMT='(I2,A)') I, ': ' // SCNAME
      ENDDO


C Get the index number of a system component
      CALL TQINSC('C ', I, NOERR)
      WRITE(*,FMT='(A,I2,A)') 'C (Carbon) is system component no. ',
     *                        I, ' in file ' // FNAME


      END

