
C Changing system components

      PROGRAM CAF11
      IMPLICIT NONE
      
      INTEGER NOERR, ISIO2
      CHARACTER SCNAME*24, NEWSC(3)*24
      DOUBLE PRECISION WMASS, STOI(3)

C Initialise ChemApp 
      CALL TQINI(NOERR)

C Open the thermochemical data-file cosi.dat (system C-O-Si)
C for reading
      CALL TQOPNA('cosi.dat', 10, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)

C Set amount unit to gram, so we get the molecular mass in g/mol
      CALL TQCSU('Amount ', 'gram ', NOERR)

C Get the name of the first system component
      CALL TQGNSC(1, SCNAME, NOERR)

C Get its molecular mass 
      CALL TQSTSC(1,STOI,WMASS,NOERR)

      WRITE(*,FMT='(A)') 'Name of first system component: ' // SCNAME
      WRITE(*,FMT='(A,G12.5)') 'Molecular mass in g/mol: ', WMASS


C Get the stoichiometry matrix of SiO2(quartz)
      CALL TQINP('SiO2(quartz) ',ISIO2,NOERR)
      CALL TQSTPC(ISIO2,1,STOI,WMASS,NOERR)

C Show the stoichiometry matrix of SiO2(quartz)
      WRITE(*,'(A)') 'Stoichiometry matrix of SiO2 ' //
     *     'in terms of system components C-O-Si:'
      WRITE(*,'(3G12.5)') STOI


C Change system components from C-O-Si to SiO-Si2C-CO2. Note that
C SiO-Si2C-CO2 form a system of three linearly independent components,
C just as the three elements C-O-Si do.
      NEWSC(1) = 'SiO'
      NEWSC(2) = 'Si2C'
      NEWSC(3) = 'CO2'

      CALL TQCSC(NEWSC,NOERR) 

C Now get the name and molecular mass of the first system 
C component again
      WRITE(*,FMT='(A)') 'After changing the system components:'

C Get the name of the first system component
      CALL TQGNSC(1, SCNAME, NOERR)

C Get its molecular mass 
      CALL TQSTSC(1,STOI,WMASS,NOERR)
      WRITE(*,FMT='(A)') 'Name of first system component: ' // SCNAME
      WRITE(*,FMT='(A,G12.5)') 'Molecular mass in g/mol: ', WMASS


C Get and display the new stoichiometry matrix for SiO2(quartz):
      CALL TQSTPC(ISIO2,1,STOI,WMASS,NOERR)
      WRITE(*,'(A)') 'Stoichiometry matrix of SiO2 ' //
     *     'in terms of system components SiO-Si2C-CO2:'
      WRITE(*,'(3G12.5)') STOI


      END

