
C Handling phases

      PROGRAM CAF12
      IMPLICIT NONE
      
      INTEGER NOERR, NPHASE, I
      CHARACTER PNAME*24, MNAME*24

C Initialise ChemApp 
      CALL TQINI(NOERR)

C Open the thermochemical data-file cosi.dat (system C-O-Si)
C for reading
      CALL TQOPNA('cosi.dat', 10, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)

C Get the number of phases
      CALL TQNOP(NPHASE, NOERR)

      WRITE(*,FMT='(A,I3)') 'Number of phases in file cosi.dat: ',
     *     NPHASE

      
C Print the names and models of all phases
      WRITE(*,FMT='(A)') 
     *     'No.      Name of phase           Model'

      DO I=1, NPHASE
         CALL TQGNP(I, PNAME, NOERR)
         CALL TQMODL(I, MNAME, NOERR)
         WRITE(*,FMT='(I3,A30,A6)') I, PNAME, MNAME
      ENDDO


C Get the index number of a phase
      CALL TQINP('SiC ', I, NOERR)
      WRITE(*,FMT='(A,I2,A)') 'SiC is phase no. ', I,
     *     ' in file cosi.dat'


      END

