
C Handling phase constituents

      PROGRAM CAF13
      IMPLICIT NONE
      
      INTEGER NOERR, NPCON, NSCOM, I
      CHARACTER PCNAME*24, SCNAME(3)*24 
      DOUBLE PRECISION WMASS, STOI(3)

C Initialise ChemApp 
      CALL TQINI(NOERR)

C Open the thermochemical data-file cosi.dat (system C-O-Si)
C for reading
      CALL TQOPNA('cosi.dat', 10, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)

C Get the number of phase constituents of the first phase in 
C cosi.dat, which is the gaseous mixture phase
      CALL TQNOPC(1, NPCON, NOERR)

      WRITE(*,FMT='(A,I3)') 'Number of phase constituents of ' //
     *     'the gas phase in cosi.dat: ', NPCON

      
C Print the names of all phase constituents of the gas phase,
C their stoichiometry in terms of the system components, 
C and their molecular mass

C Get names of the system components
      CALL TQNOSC(NSCOM, NOERR)
      DO I=1, NSCOM
         CALL TQGNSC(I, SCNAME(I), NOERR)
      ENDDO

C Print header
      WRITE(*,FMT='(A)') '                                ' //
     *     'Stoichiometry      Mol. mass'
      WRITE(*,FMT='(A)') 'No.  Name of phase const.       ' //
     *     SCNAME(1)(1:6) // 
     *     SCNAME(2)(1:6) // 
     *     SCNAME(3)(1:6) // 
     *     ' g/mol'

C Set amount unit to gram, so we get the molecular mass in g/mol
      CALL TQCSU('Amount ', 'gram ', NOERR)

C Get the information on all phase constituents of 
C the gas phase
      DO I=1, NPCON
         CALL TQGNPC(1, I, PCNAME, NOERR)
         CALL TQSTPC(1, I, STOI, WMASS, NOERR)
         WRITE(*,FMT='(I3,A26,3F6.1,2X,G12.5)') 
     *        I, PCNAME, STOI(1), STOI(2), STOI(3),
     *        WMASS
      ENDDO

      

C Get the index number of a phase constituent,
C in this case, CO2 in the gas phase
      CALL TQINPC('CO2 ', 1, I, NOERR)
      WRITE(*,FMT='(A,I2,A)') 'CO2 is phase constituent no. ',I,
     *     ' in the gas phase in file cosi.dat'


      END

