
C Set and remove equilibrium conditions

      PROGRAM CAF16
      IMPLICIT NONE
      
      INTEGER NOERR, NUMCON, ISIO2, IC, ISIC, ISI
      DOUBLE PRECISION VALS(2), RESULT

C Initialise ChemApp 
      CALL TQINI(NOERR)
      
C Open data-file for reading 
      CALL TQOPNA('cosi.dat', 10, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)

C Set conditions for a simple equilibrium calculation: temperature and
C some incoming amounts.

C Set temperature to 1900 K
      CALL TQSETC('T ', 0, 0, 1900.D0, NUMCON, NOERR)

C Set incoming amounts: 1 mol SiO2(quartz), 2 mol C, and 3 mol SiC

C Get phase index numbers for all phases and set their amounts
      CALL TQINP('SiO2(quartz)', ISIO2, NOERR)
      CALL TQSETC('IA ', ISIO2, 1, 1.D0, NUMCON, NOERR)

      CALL TQINP('C ', IC, NOERR)
      CALL TQSETC('IA ', IC, 0, 2.D0, NUMCON, NOERR)

      CALL TQINP('SiC ', ISIC, NOERR)
      CALL TQSETC('IA ', ISIC, 0, 3.D0, NUMCON, NOERR)

C Use TQSHOW to check which conditions have been set so far, or are
C active by default
      CALL TQSHOW(NOERR)


C TQSETC returns a variable (called NUMCON in this example) which can be
C used to remove a previously set condition. To do this, pass it to
C TQREMC. Here we remove the last condition set, which are the 3 mol of
C SiC
      CALL TQREMC(NUMCON, NOERR)

C Call TQSHOW again to demonstrate that it has been deleted from the
C list of active conditions
      CALL TQSHOW(NOERR)


C Calculate the equilibrium
      CALL TQCE(' ', 0, 0, VALS, NOERR)

C Get the activity of Si
      CALL TQINP('Si ', ISI, NOERR)
      CALL TQGETR('AC ', ISI, 0, RESULT, NOERR)

      WRITE(*,FMT='(1X,A,G12.5)') 'Activity of pure Si is ', RESULT


      END




