
C Retrieve error messages

      PROGRAM CAF21
      IMPLICIT NONE
      
      INTEGER NOERR, NPHASE
      CHARACTER MESS(3)*80

C Initialise ChemApp 
      CALL TQINI(NOERR)

C TQERR is especially useful if is undesirable that ChemApp writes
C error messages to the standard output unit (usually 6, the connected
C terminal). If the application program which calls ChemApp has a
C graphical user interface, ChemApp error messages written to the
C default output unit might either not be displayed at all, or might
C corrupt the graphical interface window. In these cases it is more
C useful to have ChemApp not output error messages automatically, but
C retrieve them using TQERR, if the error variable returned by a ChemApp
C subroutine indicates that an error occurred.

C Prevent the error messages from being displayed automatically
      CALL TQCIO('ERROR ', 0, NOERR)

C Provoke an error by trying to get the number of phases
C before even having read a thermochemical data-file
      CALL TQNOP(NPHASE, NOERR)
      IF (NOERR .NE. 0) THEN
         WRITE(*,FMT='(A,I4)') ' ChemApp reports error no.', NOERR

C Retrieve the error message using TQERR and the character array MESS
         CALL TQERR(MESS,NOERR)

C To display the message, print all three strings of MESS :
         WRITE(UNIT=*,FMT='(3(A,/))') MESS(1), MESS(2), MESS(3)


      ENDIF

      END

