
C Determining whether phase constituents are permitted as incoming
C species

      PROGRAM CAF25
      IMPLICIT NONE
      
      INTEGER NOERR, NPHASE, NPCON, I, J, INPCIS, NNPERM
      CHARACTER PNAME*24, PCNAME*24

C Initialise the number of phase constituents which cannot be used as
C incoming species to 0
      NNPERM = 0

C Initialise ChemApp 
      CALL TQINI(NOERR)
      
C Open data-file for reading 
      CALL TQOPNA('cosi.dat', 10, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)

C Check whether the data-file contains any phase constituents that
C cannot be used as incoming species.

C Get the number of phases
      CALL TQNOP(NPHASE, NOERR)

 100  FORMAT(1X,A,T26,A,T51,A)

C Print a table header
      WRITE(*,FMT=100) 'PHASE', 'PHASE CONSTITUENT', 
     *     'O.K./NOT PERMITTED'

C Loop over all phases
      DO I=1, NPHASE
         CALL TQGNP(I, PNAME, NOERR)
         CALL TQNOPC(I, NPCON, NOERR)

C We only need to check mixture phases
         IF (NPCON .GT. 1) THEN
C Loop over all constituents
            DO J=1, NPCON
               CALL TQGNPC(I, J, PCNAME, NOERR)
C Check whether the current constituent is permitted to be used as
C incoming species
               CALL TQPCIS(I, J, INPCIS, NOERR)

C Print a table entry, and if it is not permitted, increase the total
C number of such phase constituents by 1
               IF (INPCIS .EQ. 0) THEN
                  NNPERM = NNPERM + 1
                  WRITE(*,FMT=100) PNAME, PCNAME, 'not permitted'
               ELSE
                  WRITE(*,FMT=100) PNAME, PCNAME, 'o.k.'
               ENDIF
            ENDDO
         ENDIF
      ENDDO

C If there were phase constituents which cannot be used as incoming
C species, print a note.
      IF (NNPERM .GT. 0) THEN
         WRITE(*,FMT='(1X,A,I3,A)') 'Note: ', NNPERM, ' phase ' //
     *        'constituent(s) is/are not permitted '
         WRITE(*,FMT='(1X,A)') '        as incoming species.'
      ENDIF



      END

