
C Handling sublattice constituents

      PROGRAM CAF26
      IMPLICIT NONE
      
      INTEGER NOERR, NPHASE, NSL, NSLCON, INDEXP, INDEXL, INDEXC, I
      CHARACTER PNAME*24, CNAME*24

C Initialise ChemApp 
      CALL TQINI(NOERR)

C Open the thermochemical data-file subl-ex.dat for reading. It contains
C an extract of the system Co-Cr-Fe: the phase SIGMA:30, which is
C modelled according to the sublattice formalism, and the BCC phase,
C described by a Redlich-Kister polynomial. Both phases are each
C included twice, to account for miscibility gaps.
      CALL TQOPNA('subl-ex.dat', 10, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)
      
C The first of the two identical copies of the SIGMA:30 phase, which
C ChemApp calls SIGMA:30#1, will be investigated with respect to the
C number of sublattices, the number of sublattice constituents on each
C sublattice, and the names of the sublattice constituents.

C Get the index number for the phase SIGMA:30#1
      PNAME = 'SIGMA:30#1'
      CALL TQINP(PNAME, INDEXP, NOERR)

C Get the number of sublattices
      CALL TQNOSL(INDEXP, NSL, NOERR)
      WRITE(*,*) PNAME, ' has ', NSL, ' sublattices'

            
C Loop over all sublattices
      DO INDEXL=1, NSL

C Get the number of sublattice constituents
         CALL TQNOLC(INDEXP, INDEXL, NSLCON, NOERR)
         WRITE(*,*) 'Sublattice ', INDEXL, ' has ', NSLCON, 
     *        ' constituents with the following names:'

C Get the name of each sublattice constituent
         DO INDEXC=1, NSLCON
            CALL TQGNLC(INDEXP, INDEXL ,INDEXC, CNAME, NOERR)

C The reverse (getting the index number for the name of the sublattice
C constituent just retrieved), is rather superfluous here, and only used
C to demonstrate the call to TQINLC:
            CALL TQINLC(CNAME, INDEXP, INDEXL, I, NOERR)
            WRITE(*,*) '  ',I,':', CNAME
         ENDDO
      ENDDO


      END




