
C Using TQNOSL on various phases

      PROGRAM CAF28
      IMPLICIT NONE
      
      INTEGER NOERR, ISLITE, NUMCON, ICO, ICR, IFE, INDEXP, INDEXL,
     *     INDEXC, NPHASE, NSL, NSLCON
      DOUBLE PRECISION VAL, VALS(2), RESULT
      CHARACTER PNAME*24, MNAME*24, CNAME*24


C Initialise ChemApp 
      CALL TQINI(NOERR)
      
C Open the thermochemical data-file subl-ex.dat for reading. It contains
C an extract of the system Co-Cr-Fe: the phase SIGMA:30, which is
C modelled according to the sublattice formalism, and the BCC phase,
C described by a Redlich-Kister polynomial. Both phases are each
C included twice, to account for miscibility gaps.
      CALL TQOPNA('subl-ex.dat', 10, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)

    
      CALL TQNOP(NPHASE, NOERR)

      DO INDEXP=1, NPHASE

         CALL TQGNP(INDEXP, PNAME, NOERR)

C Get the number of sublattices
         CALL TQNOSL(INDEXP, NSL, NOERR)
                  
         WRITE(*,*) 'Phase ', PNAME, 'has ', NSL, 'sublattices'

      ENDDO
      


      END











