
C Retrieving and displaying the user ID and the name of the ChemApp
C license holder, the program ID, HASP dongle information, plus the 
C expiration date of the ChemApp license.

C If the ChemApp version used requires a HASP dongle, and the ChemApp
C license is expired, or about to expire, and is to be extended, the
C information printed by this program is needed by GTT-Technologies to
C update the dongle.

C The support function STRLEN returns the total number of characters in
C a string, not counting trailing blanks
      INTEGER FUNCTION STRLEN(INSTR)
      CHARACTER INSTR*(*)

      STRLEN = LEN(INSTR)
      DO WHILE(INSTR(STRLEN:STRLEN) .EQ. ' ')
         STRLEN = STRLEN - 1
         IF (STRLEN .EQ. 1) RETURN
      ENDDO
      RETURN
      END


      PROGRAM CAF30
      IMPLICIT NONE
      
      INTEGER NOERR, STRLEN, HASPID, EDMON, EDYEAR
      CHARACTER ID*255, NAME*80, PID*24, HASPT*5

C Initialise ChemApp 
      CALL TQINI(NOERR)
      
C Retrieve the licensee's user ID
      CALL TQGTID(ID,NOERR)

C Retrieve the licensee's name
      CALL TQGTNM(NAME,NOERR)

C Retrieve the program ID
      CALL TQGTPI(PID,NOERR)

C Print all three
      WRITE(UNIT=*,FMT=*) 'Licensee''s user ID: ', ID(1:STRLEN(ID))
      WRITE(UNIT=*,FMT=*) 'Licensee''s name   : ', NAME(1:STRLEN(NAME))
      WRITE(UNIT=*,FMT=*) 'Program ID        : ', PID(1:STRLEN(PID))

      
C The following pieces of information are only meaningful if a version
C of ChemApp is used that requires a dongle (hardware key).
C Get the HASP dongle type and id
      CALL TQGTHI(HASPT, HASPID, NOERR)

C Get the ChemApp license expiration date (month and year)
      CALL TQGTED(EDMON, EDYEAR, NOERR)

C Print info if HASP dongle is used:
      IF (HASPID .NE. 0) THEN
        WRITE(UNIT=*,FMT=*) 'HASP dongle type : ' // 
     *       HASPT(1:STRLEN(HASPT))
        WRITE(UNIT=*,FMT=*) 'HASP dongle id   : ', HASPID

        WRITE(UNIT=*,FMT=*) 'ChemApp license expiration date ' //
     *       '(month/year): ', EDMON, '/', EDYEAR
      ELSE
        WRITE(UNIT=*,FMT=*) 'This ChemApp version does not ' //
     *        'require a HASP hardware key (dongle)'
      ENDIF


      END






