
C Read a thermochemical data-file in TRANSPARENT format, then
C retrieves information on the transparent file header.

C NOTE: This example program requires a data-file in transparent format 
C       to run, which is not part of a regular distribution of ChemApp
C       or ChemApp "light".

C The support function STRLEN returns the total number of characters in
C a string, not counting trailing blanks
      INTEGER FUNCTION STRLEN(INSTR)
      CHARACTER INSTR*(*)

      STRLEN = LEN(INSTR)
      DO WHILE(INSTR(STRLEN:STRLEN) .EQ. ' ')
         STRLEN = STRLEN - 1
         IF (STRLEN .EQ. 1) RETURN
      ENDDO
      RETURN
      END


      PROGRAM CAF31
      IMPLICIT NONE
      
      INTEGER NOERR, STRLEN

C Variables to store information from various transparent file
C header (TFH) fields
      CHARACTER TFHID*255, TFHUSR*80,TFHNWP*40,TFHNRP*40,TFHREM*80
      INTEGER TFHVER, TFHVNW(3), TFHVNR(3), TFHDTC(6), TFHDTE(6)


 10   FORMAT(1X,A,I4.4,5(A1,I2.2))

C Initialise ChemApp 
      CALL TQINI(NOERR)
      
C Open transparent data-file for reading.
      CALL TQOPNT('cosiex.cst', 10, NOERR)

C Read data-file 
      CALL TQRCST(NOERR)

C Close data-file 
      CALL TQCLOS(10, NOERR)

C Once the transparent data-file has been read, information on its 
C header can be retrieved.
      CALL TQGTRH(TFHVER, TFHNWP, TFHVNW, TFHNRP, TFHVNR, TFHDTC,
     *     TFHDTE, TFHID, TFHUSR, TFHREM, NOERR)
      
      WRITE(UNIT=*, FMT=*) 'Version number of the transparent file ' //
     *     'header format:', TFHVER
      WRITE(UNIT=*, FMT=*) 'Name of the program which wrote the ' //
     *     'data-file: ', TFHNWP(1:STRLEN(TFHNWP))
      WRITE(UNIT=*, FMT=*) 'Version number of the writing program: ',
     *     TFHVNW(1), '.', TFHVNW(2), '.', TFHVNW(3)
      WRITE(UNIT=*, FMT=*) 'Programs which are permitted to read ' //
     *     'the data-file: ', TFHNRP(1:STRLEN(TFHNRP))
      WRITE(UNIT=*, FMT=*) 'Min. version number of the reading ' //
     *     'program: ', TFHVNR(1), '.', TFHVNR(2), '.', TFHVNR(3)
      WRITE(UNIT=*, FMT=10) 'File was created on ', 
     *     TFHDTC(1),'/', TFHDTC(2),'/',TFHDTC(3),' ', 
     *     TFHDTC(4),':',TFHDTC(5),':',TFHDTC(6)
      WRITE(UNIT=*, FMT=10) 'File will expire on ', 
     *     TFHDTE(1),'/', TFHDTE(2),'/',TFHDTE(3),' ', 
     *     TFHDTE(4),':',TFHDTE(5),':',TFHDTE(6)
      WRITE(UNIT=*, FMT=*) 'Licensee''s user ID(s): ', 
     *     TFHID(1:STRLEN(TFHID))
      WRITE(UNIT=*, FMT=*) 'Licensee''s name: ', 
     *     TFHUSR(1:STRLEN(TFHUSR))
      WRITE(UNIT=*, FMT=*) 'Remarks: ', 
     *     TFHREM(1:STRLEN(TFHREM))


      END


