
C Redirecting ChemApp output and user-defined text to the same file

      PROGRAM CAF32
      IMPLICIT NONE
      
      INTEGER NOERR, FUNIT, LUNIT, IPC, NUMCON
      CHARACTER LOGTXT*80
      DOUBLE PRECISION CO2AMT, DARR2(2)

C Initialise ChemApp 
      CALL TQINI(NOERR)

C Get the unit number from which the thermochemical data-file
C will be read
      CALL TQGIO('FILE ', FUNIT, NOERR)

C Open the thermochemical data-file cosi.dat (system C-O-Si)
C for reading
      CALL TQOPNA('cosi.dat', FUNIT, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(FUNIT, NOERR)

C Input 3 mol of CO2/GAS/
      CO2AMT = 3.D0
      CALL TQINPC('CO2', 1, IPC, NOERR)
      CALL TQSETC('IA ', 1, IPC, CO2AMT, NUMCON, NOERR)

C Redirect 'LIST' output (e.g. output from TQCEL) to a different
C unit number
      LUNIT = 21
      CALL TQCIO('LIST ', LUNIT, NOERR)

C Open a file under this unit number
      CALL TQOPEN('caf32.rst', LUNIT, NOERR)
 
C Write a descriptive text to file 'result'
      CALL TQWSTR('LIST ', 'Output from TQCEL (ChemSage result table)',
     *     NOERR)
      
 100  FORMAT(A,G8.3)
      WRITE(LOGTXT, FMT=100) 'Incoming amount of CO2 in mol: ', CO2AMT

      CALL TQWSTR('LIST ', LOGTXT, NOERR)

C Write ChemSage result table to file 'result'
      CALL TQCEL(' ',0,0,DARR2,NOERR) 

C Direct 'LIST' output back to the standard output unit
      CALL TQCIO('LIST ', 6, NOERR)

C Close the file 'result'
      CALL TQCLOS(LUNIT, NOERR)

      END








