
C Redirecting ChemApp output and user-defined text to the same file

      PROGRAM CAF33
      IMPLICIT NONE
      
      INTEGER NOERR, FUNIT, LUNIT, IPC, I, NUMCON
      CHARACTER LOGTXT*80, FTQSHO*20, FTQCEL*20 
      DOUBLE PRECISION DARR2(2), CO2AMT

C Initialise ChemApp 
      CALL TQINI(NOERR)

C Initialize counter
C      I = 0

C Get the unit number from which the thermochemical data-file
C will be read
      CALL TQGIO('FILE ', FUNIT, NOERR)

C Open the thermochemical data-file cosi.dat (system C-O-Si)
C for reading
      CALL TQOPNA('cosi.dat', FUNIT, NOERR)

C Read data-file 
      CALL TQRFIL(NOERR)

C Close data-file 
      CALL TQCLOS(FUNIT, NOERR)

C Redirect 'LIST' output (e.g. output from TQCEL) to a different
C unit number
      LUNIT = 21
      CALL TQCIO('LIST ', LUNIT, NOERR)
      CALL TQCIO('ERROR ', LUNIT, NOERR)

      CALL TQINPC('CO2', 1, IPC, NOERR)


      do i=1, 20

      write(*,*) i


C Input
      CO2AMT = 0.D0
      CALL TQSETC('IA ', 1, IPC, CO2AMT, NUMCON, NOERR)

 101  FORMAT('ca', I6.6, '.tqs')
 102  FORMAT('ca', I6.6, '.tqc')
      WRITE(FTQSHO, FMT=101) i
      WRITE(FTQCEL, FMT=102) i

C Open a TQSHOW log file under this unit number
      OPEN(UNIT=LUNIT, FILE=FTQSHO, STATUS='UNKNOWN')
 
C Write TQSHOW output to this log file
      CALL TQSHOW(NOERR)

C Close this file again
      CLOSE(UNIT=LUNIT, STATUS='KEEP')


C Open a TQCEL log file under this unit number
      OPEN(UNIT=LUNIT, FILE=FTQCEL, STATUS='UNKNOWN')
 
C Calculate equilibrium and write ChemSage result table to the file
      CALL TQCEL(' ',0,0,DARR2,NOERR) 

      if (noerr .gt. 0) then
C There has been an error calculating the equilibrium         
         CLOSE(UNIT=LUNIT, STATUS='KEEP')

      else
C The equilibrium was successfully calculated
         CLOSE(UNIT=LUNIT, STATUS='DELETE')
         
C Delete also the TQSHOW log file
      OPEN(UNIT=LUNIT, FILE=FTQSHO, STATUS='UNKNOWN')
      CLOSE(UNIT=LUNIT, STATUS='DELETE')

      ENDIF



      enddo








C Direct 'LIST' output back to the standard output unit
      CALL TQCIO('LIST ', 6, NOERR)

C Close the file 'result'
      CALL TQCLOS(LUNIT, NOERR)

      END








